package com.bsoft.api.controller;

import com.bsoft.api.common.Result;
import com.bsoft.api.common.annotations.Token;
import com.bsoft.api.model.reqmodel.AddBudgetValue;
import com.bsoft.api.model.reqmodel.QueryBudgetValue;
import com.bsoft.api.model.reqmodel.QuerySummary;
import com.bsoft.api.service.SerProjValueService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Api(tags = "预算编制Api")
@RestController
public class SerProjValueController {
    @Resource
    private SerProjValueService projValueService;

    @PostMapping("budget/value")
    @Token
    @ApiOperation("查询预算编制数据")
    public Object getProjValue(@RequestBody QueryBudgetValue request) throws Throwable {
        Object result = projValueService.getValue(request.getProjectType(),request.getDate(),request.getDeptCode());
        return Result.success(result);

    }

    @PostMapping("budget/save")
    @Token
    @ApiOperation("保存数据")
    public Object save(@RequestBody AddBudgetValue request) throws Throwable {
        boolean result = projValueService.save(request);
        if(result)
            return Result.success(null);
        else
            return Result.error();
    }

    @PostMapping("budget/summary")
    @Token
    @ApiOperation("查询预算编制汇总数据")
    public Object getSummary(@RequestBody QuerySummary request) throws Throwable {
        Object result = projValueService.getSummary(request.getDate());
        return Result.success(result);
    }
}
